local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

local remainingKegSmashCD
a.keepupShuffle = function()
	remainingKegSmashCD = s.SpellCooldown(121253--[[Keg Smash]])
	if (remainingKegSmashCD + 2 ) < x.ShuffleDuration then
		return true
	end
	if ((x.Chi - 2) >= 2) and x.ShuffleDuration > 1 then
		return true
	end
	if ((x.Chi - 2) == 1) and x.ShuffleDuration > 2 then
		return true
	end
	if ((x.Chi - 2) == 0) and x.ShuffleDuration > 3 then
		return true
	end
	return false
end

local regenRate
a.energyRegeneration = function()
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	if s.Buff(115288--[[Energizing Brew]], "player") then
		regenRate = regenRate + 10
	end
	return regenRate
end

a.specCheck = function()
	if x.Spec == 1 then
		return a.keepupShuffle()
	elseif x.Spec == 2 then
		return true
	elseif x.Spec == 3 then
		return s.InCombat() and not x.Channeling
	else
		return true
	end
end

local HasteCDs = {
	49016--[[Unholy Frenzy]],
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
	26297--[[Berserking]],
	3045--[[Rapid Fire]],
	105919--[[Chronohunter]],
}
a.Hasted = function()
	return s.Buff(HasteCDs, "player")
end

-- Detect raid-wide haste buffs, so we know when to
-- use potions
local BloodlustSpells = {
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
	90355--[[Ancient Hysteria]],
}
a.Bloodlust = function()
	return s.Buff(BloodlustSpells, "player")
end